<template>
    <div class="content-wrapper">
        <section class="content">
            <div class="container-fluid">
                <div>
                    <h2>Сотрудники</h2>
                </div>
                <div v-if="lvl >= 2">
                    <!-- Button trigger modal -->
                    <button type="button" class="btn btn-success" data-toggle="modal" data-target="#addUserModal">
                        Добавить
                    </button>

                    <!-- Modal -->
                    <div class="modal fade" id="addUserModal" tabindex="-1" role="dialog" aria-labelledby="addUserModalLabel" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="addUserModalLabel">Добавить сотрудника</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                    <form @submit.prevent="createNewUser">
                                        <div class="modal-body">
                                            <div class="mb-3">
                                                <label for="image" class="form-label">Фото</label>
                                                <input type="text" class="form-control" id="image" v-model="newUser.image">
                                                <label for="name" class="form-label">Имя</label>
                                                <input type="text" class="form-control" id="name" v-model="newUser.name">
                                                <label for="position" class="form-label">Должность</label>
                                                <input type="text" class="form-control" id="position" v-model="newUser.position">
                                                <label for="date" class="form-label">Дата</label>
                                                <input type="date" class="form-control" id="date" v-model="newUser.date">
                                                <label for="phone" class="form-label">Телефон</label>
                                                <input type="text" class="form-control" id="phone" v-model="newUser.phone">
                                                <label for="email" class="form-label">Почта</label>
                                                <input type="email" class="form-control" id="email" v-model="newUser.email">
                                                <label for="salary" class="form-label">Зарплата</label>
                                                <input type="text" class="form-control" id="salary" v-model="newUser.salary">
                                            </div>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Закрыть</button>
                                            <button type="submit" class="btn btn-primary">Добавить</button>
                                        </div>
                                    </form>
                            </div>
                        </div>
                    </div>
                </div>
                <table class="table">
                    <thead>
                    <tr>
                        <th>Фото</th>
                        <th>Имя</th>
                        <th>Должность</th>
                        <th>Дата</th>
                        <th>Номер телефона</th>
                        <th>Почта</th>
                        <th>Зарплата</th>
                        <th v-if="lvl >= 2">Действия</th>
                    </tr>
                    </thead>
                    <UserCard v-for="user in users" :key="user.id" :user="user" :lvl="lvl"/>
                </table>
                <nav aria-label="...">
                    <ul class="pagination">
                        <li class="page-item">
                            <a @click="updatePage(currentPage - 1, $event)"
                               :class="['page-link', {'disabled': currentPage === 1}]"
                               href="#" tabindex="-1" aria-disabled="true">
                                Предыдущая
                            </a>
                        </li>
                        <li class="page-item"
                            :class="{ 'active': page === currentPage }"
                            v-for="page in displayPages"
                            :key="page"
                            v-if="page <= lastPage">
                            <a @click="updatePage(page, $event)"
                               :class="['page-link']"
                               href="#">
                                {{ page }}
                            </a>
                        </li>
                        <li class="page-item">
                            <a @click="updatePage(currentPage + 1, $event)"
                               :class="['page-link', {'disabled': currentPage === lastPage}]"
                               href="#">
                                Следующая
                            </a>
                        </li>
                    </ul>
                </nav>
            </div>
        </section>
    </div>
</template>

<script>
import UserCard from "./UserCard.vue";
import { mapActions, mapGetters, mapMutations } from "vuex";

export default {
    name: "Main",
    components: {
        UserCard
    },
    data() {
        return {
            newUser: {
                image: '',
                name: '',
                position: '',
                date: '',
                phone: '',
                email: '',
                salary: ''
            }
        }
    },
    computed: {
        ...mapGetters('adminPanel', ['users', 'currentPage', 'lastPage']),
        ...mapGetters('auth', ['lvl']),
        displayPages() {
            const pages = [1];
            const startPage = this.currentPage === 1 ? 1 : this.currentPage;
            const endPage = startPage + 4;

            for (let i = startPage; i <= endPage; i++) {
                if (this.currentPage === 1){
                    pages.push(i + 1);
                } else {
                    pages.push(i);
                }
            }

            return pages;
        }

    },
    methods: {
        ...mapActions('adminPanel',['showUsers', 'addUser']),
        ...mapMutations('adminPanel', ['setCurrentPage']),
        updatePage(page, event) {
            event.preventDefault();
            this.setCurrentPage(page);
            this.showUsers(page);
        },
        async createNewUser() {
            await this.addUser(this.newUser);
            this.newUser =  {
                image: '',
                name: '',
                position: '',
                date: '',
                phone: '',
                email: '',
                salary: ''
            };
        }
    },
    mounted() {
        this.showUsers();
    }
}
</script>
